Index: /trunk/src/world_entities/world_entity.cc
===================================================================
--- /trunk/src/world_entities/world_entity.cc	(revision 7953)
+++ /trunk/src/world_entities/world_entity.cc	(revision 7954)
@@ -70,5 +70,6 @@
   this->toList(OM_NULL);
 
-  //this->collisionHandles = new *CollisionHandle[CREngine::CR_NUMBER]();
+  modelFileName_handle = registerVarId( new SynchronizeableString( &modelFileName, &modelFileName, "modelFileName" ) );
+  scaling_handle = registerVarId( new SynchronizeableFloat( &scaling, &scaling, "scaling" ) );
 }
 
@@ -132,4 +133,14 @@
   this->modelLODName = fileName;
   this->scaling = scaling;
+
+  std::string name = fileName;
+
+  if (  name.find( ResourceManager::getInstance()->getDataDir() ) == 0 )
+  {
+    name.erase(ResourceManager::getInstance()->getDataDir().size());
+  }
+
+  this->modelFileName = name;
+
   if (!fileName.empty())
   {
@@ -524,93 +535,18 @@
 
 
-
-
-/********************************************************************************************
- NETWORK STUFF
- ********************************************************************************************/
-
-
-/**
- * Writes data from network containing information about the state
- * @param data pointer to data
- * @param length length of data
- * @param sender hostID of sender
- */
-int WorldEntity::writeState( const byte * data, int length, int sender )
-{
-  std::string modelFileName;
-  SYNCHELP_READ_BEGIN();
-
-  SYNCHELP_READ_FKT( PNode::writeState, NWT_WE_PN_WRITESTATE );
-
-  SYNCHELP_READ_STRING( modelFileName, NWT_WE_PN_MODELFILENAME );
-  SYNCHELP_READ_FLOAT( scaling, NWT_WE_PN_SCALING );
-  //check if modelFileName is relative to datadir or absolute
-
-
-  PRINTF(0)("================ LOADING MODEL %s, %f\n", modelFileName.c_str(), scaling);
-
-  if ( modelFileName != "" )
-  {
-    loadModel( modelFileName, scaling);
-    PRINTF(0)("modelfilename: %s\n", getModel( 0 )->getName());
-  }
-
-  /*SYNCHELP_READ_STRINGM( modelFileName );
-
-  if ( strcmp(modelFileName, "") )
-    if ( strstr(modelFileName, ResourceManager::getInstance()->getDataDir()) )
-    {
-      this->md2TextureFileName = new char[strlen(modelFileName)-strlen(ResourceManager::getInstance()->getDataDir())+1];
-      strcpy((char*)this->md2TextureFileName, modelFileName+strlen(ResourceManager::getInstance()->getDataDir()));
-    }
-    else
-    {
-      this->md2TextureFileName = modelFileName;
-    }
-  */
-
-  return SYNCHELP_READ_N;
-}
-
-
-/**
- * data copied in data will bee sent to another host
- * @param data pointer to data
- * @param maxLength max length of data
- * @return the number of bytes writen
- */
-int WorldEntity::readState( byte * data, int maxLength )
-{
-  SYNCHELP_WRITE_BEGIN();
-
-  SYNCHELP_WRITE_FKT( PNode::readState, NWT_WE_PN_WRITESTATE );
-
-  if ( getModel(0) && getModel(0)->getName() != "" )
-  {
-    std::string name = getModel( 0 )->getName();
-
-    if (  name.find( ResourceManager::getInstance()->getDataDir() ) == 0 )
-    {
-      name.erase(ResourceManager::getInstance()->getDataDir().size());
-    }
-
-    SYNCHELP_WRITE_STRING( name, NWT_WE_PN_MODELFILENAME );
-  }
-  else
-  {
-    SYNCHELP_WRITE_STRING("", NWT_WE_PN_MODELFILENAME);
-  }
-
-  SYNCHELP_WRITE_FLOAT( scaling, NWT_WE_PN_SCALING );
-  /*if ( this->md2TextureFileName!=NULL && strcmp(this->md2TextureFileName, "") )
-  {
-    SYNCHELP_WRITE_STRING(this->md2TextureFileName);
-  }
-  else
-  {
-    SYNCHELP_WRITE_STRING("");
-  }*/
-
-  return SYNCHELP_WRITE_N;
-}
+/**
+ * handler for changes on registred vars
+ * @param id id's which changed
+ */
+void WorldEntity::varChangeHandler( std::list< int > & id )
+{
+  if ( std::find( id.begin(), id.end(), modelFileName_handle ) != id.end() ||
+       std::find( id.begin(), id.end(), scaling_handle ) != id.end()
+     )
+  {
+    loadModel( modelFileName, scaling );
+  }
+
+  PNode::varChangeHandler( id );
+}
+
Index: /trunk/src/world_entities/world_entity.h
===================================================================
--- /trunk/src/world_entities/world_entity.h	(revision 7953)
+++ /trunk/src/world_entities/world_entity.h	(revision 7954)
@@ -99,4 +99,6 @@
   OrxGui::GLGuiWidget* getHealthWidget();
   bool hasHealthWidget() const { return this->healthWidget; };
+  
+  virtual void varChangeHandler( std::list<int> & id );
 
   /* --- Misc Stuff Block --- */
@@ -133,5 +135,12 @@
   ObjectManager::EntityList::iterator objectListIterator; //!< The iterator position of this Entity in the given list of the ObjectManager.
 
-  float                   scaling;
+  
+  //network stuff
+  
+  float       scaling;                         //!< model's scaling factor
+  int         scaling_handle;                  //!< handle for syncing var
+  
+  std::string modelFileName;                  //!< model's file name
+  int         modelFileName_handle;           //!< handle for syncing var
   CollisionHandle**       collisionHandles;
 
